package org.spagic3.components.bpm.handler;

import java.util.Map;

import org.eclipse.ebpm.integration.api.IWorkflowContextWorker;
import org.jbpm.context.exe.ContextInstance;
import org.jbpm.graph.exe.ExecutionContext;
import org.spagic3.components.bpm.BPMContextSingleton;

public abstract class AbstractExchangeWorker implements IWorkflowContextWorker {
	
	public boolean workingOnParts = false;
	public String variableName = BPMContextSingleton.XML_MESSAGE;
	public String currentIndexVariableName = null;
	
	
	public String getCurrentIndexVariableName() {
		return currentIndexVariableName;
	}

	public void setCurrentIndexVariableName(String currentIndexVariableName) {
		this.currentIndexVariableName = currentIndexVariableName;
	}

	public boolean isWorkingOnParts() {
		return workingOnParts;
	}

	public void setWorkingOnParts(boolean workingOnParts) {
		this.workingOnParts = workingOnParts;
	}
	
	public String getXMLMessage(Object workflowContext){
		ExecutionContext executionContext = (ExecutionContext)workflowContext;
		
		String realVariableNameToRetrieve = resolveVariableName(workflowContext);
		return (String)getVariable(executionContext, realVariableNameToRetrieve);
	}
	
	@Override
	public String resolveVariableName(Object workflowContext) {
		ExecutionContext executionContext = (ExecutionContext)workflowContext;
		if (isWorkingOnParts()){
			Integer currentIndex = (Integer)getVariable(executionContext, currentIndexVariableName);
			return  getPartIVariableName(currentIndex);
		}else{
			return getVariableName();
		}
	}
	
	public String getPartIVariableName(int i){
		return variableName + "_PART_["+i+"]";
	}
	
	

	@Override
	public String getVariableName() {
		return this.variableName;
	}

	@Override
	public void setVariableName(String varName) {
		this.variableName = varName;
		
	}
	
	
	
	public Map<String, String> getProperties() {
		// TODO Auto-generated method stub
		return null;
	}

	
	public void setProperties(Map<String, String> properties) {
		// TODO Auto-generated method stub
		
	}
	
	
	public Object getVariable(ExecutionContext executionContext, String variableName){
		
		ContextInstance contextInstance = executionContext.getContextInstance();
		return contextInstance.getVariable(variableName, executionContext.getToken());
	}
	
	public void setVariable(ExecutionContext executionContext, String variableName, Object value){
		ContextInstance contextInstance = executionContext.getContextInstance();
		contextInstance.setVariable(variableName, value,  executionContext.getToken());
	}	

	public void deleteVariable(ExecutionContext executionContext,  String variableName){
		ContextInstance contextInstance = executionContext.getContextInstance();
		contextInstance.deleteVariable(variableName, executionContext.getToken());
	}	
	
	
}
