package org.spagic3.components.bpm.handler.loop;

import org.jbpm.graph.def.ActionHandler;
import org.jbpm.graph.exe.ExecutionContext;


public abstract class AbstractBaseLoopHandler implements ActionHandler {

	protected static final String LOOP_CURRENT_INDEX_NAME = "LOOP_CURRENT_INDEX_NAME";
	private String lastIndexVariableName = null;
	private String aggregatorTag = null;
	private String xPathExpression = null;
	private String variableName = null;
	private String currentIndexVariableName = null;
	
	public String getVariableName() {
		return variableName;
	}
	public void setVariableName(String variableName) {
		this.variableName = variableName;
	}
	public String getCurrentIndexVariableName() {
		return currentIndexVariableName;
	}
	public void setCurrentIndexVariableName(String currentIndexVariableName) {
		this.currentIndexVariableName = currentIndexVariableName;
	}
	
	public String getPartIVariableName(int i){
		return variableName + "_PART_["+i+"]";
	}
	
	public String getLastIndexVariableName() {
		return lastIndexVariableName;
	}
	public void setLastIndexVariableName(String lastIndexVariableName) {
		this.lastIndexVariableName = lastIndexVariableName;
	}
	public String getAggregatorTag() {
		return aggregatorTag;
	}
	public void setAggregatorTag(String aggregatorTag) {
		this.aggregatorTag = aggregatorTag;
	}
	public String getXPathExpression() {
		return xPathExpression;
	}
	public void setXPathExpression(String xPathExpression) {
		this.xPathExpression = xPathExpression;
	}
	
	
	
	public Object getVariable(ExecutionContext executionContext, org.jbpm.graph.exe.ProcessInstance pi, String variableName){
		return pi.getContextInstance().getVariable(variableName, executionContext.getToken());
	}
	
	public void setVariable(ExecutionContext executionContext, org.jbpm.graph.exe.ProcessInstance pi, String variableName, Object value){
		pi.getContextInstance().setVariable(variableName, value, executionContext.getToken());
	}	

	public void deleteVariable(ExecutionContext executionContext, org.jbpm.graph.exe.ProcessInstance pi, String variableName){
		pi.getContextInstance().deleteVariable(variableName, executionContext.getToken());
	}	
	
	public void saveAndSignal(ExecutionContext executionContext, org.jbpm.graph.exe.ProcessInstance pi){
		executionContext.getJbpmContext().save(pi);
		executionContext.getToken().signal();
	}
}
