package org.spagic3.components.bpm.handler.loop;

import java.util.List;

import org.dom4j.Document;
import org.dom4j.DocumentHelper;
import org.dom4j.Node;
import org.jbpm.graph.exe.ExecutionContext;

public class SplitPartsHandler extends AbstractBaseLoopHandler {

	/**
	 * 
	 */
	
	
	private static final long serialVersionUID = 1409185099507278025L;

	@Override
	public void execute(ExecutionContext executionContext) throws Exception {

		org.jbpm.graph.exe.ProcessInstance pi = executionContext.getToken().getProcessInstance();
		
		String xml = (String)getVariable(executionContext, pi, getVariableName());
		Document doc = DocumentHelper.parseText(xml);
		List<Node> nodes = doc.selectNodes(getXPathExpression());
		
		int size = nodes.size();
		for (int i =0; i < nodes.size(); i++){
			Node n = nodes.get(i);
			setVariable(executionContext, pi, getPartIVariableName(i), n.asXML()); 
		}
		
		setVariable(executionContext, pi, LOOP_CURRENT_INDEX_NAME, getCurrentIndexVariableName());
		setVariable(executionContext, pi, getCurrentIndexVariableName(), 0);
		setVariable(executionContext, pi, getLastIndexVariableName(), size);
		saveAndSignal(executionContext, pi);
		
	}

}
